aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorPeter Mikus <pmikus@cisco.com>2019-09-13 12:00:49 +0000
committerPeter Mikus <pmikus@cisco.com>2019-10-30 07:40:07 +0000
commit62de349145b7868b80eba5577e64e7374e397fe1 (patch)
tree22fd1589f8da5f6e658e39147cac43ff319b1ec5
parent5e89137d55a693025a6206ad4c6f6dedef167e3e (diff)
Add: Use containers for shared TG
+ Ansible + Service for auto load during restart + By default created 2 instances of Docker container + Small modification of Trex to use prefixes + DNV topology to use ssh port to connect to docker Signed-off-by: Peter Mikus <pmikus@cisco.com> Change-Id: Ibc2b2f0e509d920fc3e05d012b88abc388f5c3e7 (cherry picked from commit 96eaabff284f154ca96ce823fee205bd9833043b) (cherry picked from commit 744f1b25218b2a72be351056ff68af5f6a899bca)
-rw-r--r--resources/libraries/python/TrafficGenerator.py4
-rw-r--r--resources/tools/testbed-setup/ansible/inventories/lf_inventory/host_vars/10.32.8.10.yaml1
-rw-r--r--resources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.service12
-rwxr-xr-xresources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.sh56
-rw-r--r--resources/tools/testbed-setup/ansible/roles/tg/handlers/main.yaml9
-rw-r--r--resources/tools/testbed-setup/ansible/roles/tg/tasks/main.yaml28
-rw-r--r--topologies/available/lf_2n_dnv_testbed26.yaml4
-rw-r--r--topologies/available/lf_3n_dnv_testbed35.yaml4
8 files changed, 112 insertions, 6 deletions
diff --git a/resources/libraries/python/TrafficGenerator.py b/resources/libraries/python/TrafficGenerator.py
index 57ff22424d..93de0d74aa 100644
--- a/resources/libraries/python/TrafficGenerator.py
+++ b/resources/libraries/python/TrafficGenerator.py
@@ -339,8 +339,8 @@ class TrafficGenerator(AbstractMeasurer):
# Start TRex.
cmd = ("sh -c 'cd {dir}/scripts/ && "
- "nohup ./t-rex-64 {mode} -i -c 7 > "
- "/tmp/trex.log 2>&1 &' > /dev/null"
+ "nohup ./t-rex-64 {mode} --prefix $(hostname)"
+ " -i -c 7 > /tmp/trex.log 2>&1 &' > /dev/null"
.format(dir=Constants.TREX_INSTALL_DIR,
mode='--astf' if osi_layer == 'L7' else ''))
try:
diff --git a/resources/tools/testbed-setup/ansible/inventories/lf_inventory/host_vars/10.32.8.10.yaml b/resources/tools/testbed-setup/ansible/inventories/lf_inventory/host_vars/10.32.8.10.yaml
index f2091b71a8..dc89370a42 100644
--- a/resources/tools/testbed-setup/ansible/inventories/lf_inventory/host_vars/10.32.8.10.yaml
+++ b/resources/tools/testbed-setup/ansible/inventories/lf_inventory/host_vars/10.32.8.10.yaml
@@ -16,3 +16,4 @@ sysctl:
inventory_ipmi_hostname: '10.30.55.10'
cobbler_profile: 'ubuntu-18.04.2-server-x86_64'
cpu_microarchitecture: "skylake"
+docker_tg: true
diff --git a/resources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.service b/resources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.service
new file mode 100644
index 0000000000..11911201d5
--- /dev/null
+++ b/resources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.service
@@ -0,0 +1,12 @@
+[Unit]
+Description=CSIT Initialize Docker TG
+After=network.target
+
+[Service]
+Type=oneshot
+RemainAfterExit=True
+ExecStart=/usr/local/bin/csit-initialize-docker-tg.sh start 2
+ExecStop=/usr/local/bin/csit-initialize-docker-tg.sh stop
+
+[Install]
+WantedBy=default.target
diff --git a/resources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.sh b/resources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.sh
new file mode 100755
index 0000000000..0c6dbee492
--- /dev/null
+++ b/resources/tools/testbed-setup/ansible/roles/tg/files/csit-initialize-docker-tg.sh
@@ -0,0 +1,56 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2019 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# CSIT SRIOV VF initialization and isolation.
+
+set -euo pipefail
+
+case "${1:-start}" in
+ "start" )
+ # Run TG
+ for cnt in $(seq 1 ${2:-1}); do
+ # If the IMAGE is not already loaded then docker run will pull the
+ # IMAGE, and all image dependencies, before it starts the container.
+ dcr_image="snergster/csit-sut:latest"
+ # Run the container in the background and print the new container
+ # ID.
+ dcr_stc_params="--detach=true "
+ # Give extended privileges to this container. A "privileged"
+ # container is given access to all devices and able to run nested
+ # containers.
+ dcr_stc_params+="--privileged "
+ # Publish all exposed ports to random ports on the host interfaces.
+ dcr_stc_params+="--publish 600${cnt}:22 "
+ # Automatically remove the container when it exits.
+ dcr_stc_params+="--rm "
+ # Size of /dev/shm.
+ dcr_stc_params+="--shm-size 4G "
+ # Mount vfio to be able to bind to see binded interfaces. We cannot
+ # use --device=/dev/vfio as this does not see newly binded
+ # interfaces.
+ dcr_stc_params+="--volume /dev:/dev "
+ # Mount /opt/boot/ where VM kernel and initrd are located.
+ dcr_stc_params+="--volume /opt:/opt "
+ # Mount host hugepages for VMs.
+ dcr_stc_params+="--volume /dev/hugepages:/dev/hugepages "
+
+ params=(${dcr_stc_params} --name csit-tg-"${cnt}" "${dcr_image}")
+ docker run "${params[@]}"
+ done
+ ;;
+ "stop" )
+ docker rm --force $(docker ps --all --quiet --filter name=csit-tg)
+ ;;
+esac
diff --git a/resources/tools/testbed-setup/ansible/roles/tg/handlers/main.yaml b/resources/tools/testbed-setup/ansible/roles/tg/handlers/main.yaml
new file mode 100644
index 0000000000..53cbb48e0a
--- /dev/null
+++ b/resources/tools/testbed-setup/ansible/roles/tg/handlers/main.yaml
@@ -0,0 +1,9 @@
+---
+# file: roles/tg/handlers/main.yaml
+
+- name: Start csit-initialize-docker-tg.service
+ systemd:
+ enabled: yes
+ state: 'started'
+ name: 'csit-initialize-docker-tg.service'
+ tags: docker-tg
diff --git a/resources/tools/testbed-setup/ansible/roles/tg/tasks/main.yaml b/resources/tools/testbed-setup/ansible/roles/tg/tasks/main.yaml
index 24f433f9b9..62629d7a51 100644
--- a/resources/tools/testbed-setup/ansible/roles/tg/tasks/main.yaml
+++ b/resources/tools/testbed-setup/ansible/roles/tg/tasks/main.yaml
@@ -7,3 +7,31 @@
- name: Install WRK
include_tasks: 'wrk.yaml'
tags: install-wrk
+
+- name: Install TRex
+ include_tasks: 'trex.yaml'
+ tags: install-trex
+
+- name: Copy csit-initialize-docker-tg.sh
+ copy:
+ src: 'files/csit-initialize-docker-tg.sh'
+ dest: '/usr/local/bin/csit-initialize-docker-tg.sh'
+ owner: 'root'
+ group: 'root'
+ mode: '744'
+ when: docker_tg is defined
+ tags: docker-tg
+
+- name: Start csit-initialize-docker-tg.service
+ copy:
+ src: 'files/csit-initialize-docker-tg.service'
+ dest: '/etc/systemd/system/'
+ owner: 'root'
+ group: 'root'
+ mode: '644'
+ notify:
+ - 'Start csit-initialize-docker-tg.service'
+ when: docker_tg is defined
+ tags: docker-tg
+
+- meta: flush_handlers
diff --git a/topologies/available/lf_2n_dnv_testbed26.yaml b/topologies/available/lf_2n_dnv_testbed26.yaml
index 9b0d1328f3..c844323b65 100644
--- a/topologies/available/lf_2n_dnv_testbed26.yaml
+++ b/topologies/available/lf_2n_dnv_testbed26.yaml
@@ -12,8 +12,8 @@ nodes:
subtype: TREX
host: "10.32.8.10"
arch: x86_64
- port: 22
- username: testuser
+ port: 6001
+ username: root
password: Csit1234
interfaces:
port1:
diff --git a/topologies/available/lf_3n_dnv_testbed35.yaml b/topologies/available/lf_3n_dnv_testbed35.yaml
index da2892fc35..934e11a85a 100644
--- a/topologies/available/lf_3n_dnv_testbed35.yaml
+++ b/topologies/available/lf_3n_dnv_testbed35.yaml
@@ -12,8 +12,8 @@ nodes:
subtype: TREX
host: "10.32.8.10"
arch: x86_64
- port: 22
- username: testuser
+ port: 6002
+ username: root
password: Csit1234
interfaces:
port1: